Index: CKEditor/trunk/_source/lang/zh.js
===================================================================
--- CKEditor/trunk/_source/lang/zh.js	(revision 5181)
+++ CKEditor/trunk/_source/lang/zh.js	(revision 5189)
@@ -1,3 +1,3 @@
-﻿/*
+/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -32,5 +32,9 @@
 	 * of reading non-English words. So be careful while translating it.
 	 */
-	editorTitle		: '文書處理器, %1',
+	editorTitle : 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+
+	// ARIA descriptions.
+	toolbar	: 'Toolbar', // MISSING
+	editor	: 'Rich Text Editor', // MISSING
 
 	// Toolbar buttons without dialogs.
@@ -69,10 +73,10 @@
 		form			: '表單',
 		checkbox		: '核取方塊',
-		radio		: '選項按鈕',
+		radio			: '選項按鈕',
 		textField		: '文字方塊',
 		textarea		: '文字區域',
 		hiddenField		: '隱藏欄位',
 		button			: '按鈕',
-		select	: '清單/選單',
+		select			: '清單/選單',
 		imageButton		: '影像按鈕',
 		notSet			: '<尚未設定>',
@@ -89,9 +93,17 @@
 		ok				: '確定',
 		cancel			: '取消',
+		close			: 'Close', // MISSING
+		preview			: 'Preview', // MISSING
 		generalTab		: '一般',
 		advancedTab		: '進階',
-		validateNumberFailed	: '需要輸入數字格式',
+		validateNumberFailed : '需要輸入數字格式',
 		confirmNewPage	: '現存的修改尚未儲存，要開新檔案？',
 		confirmCancel	: '部份選項尚未儲存，要關閉對話盒？',
+		options			: 'Options', // MISSING
+		target			: 'Target', // MISSING
+		targetNew		: 'New Window (_blank)', // MISSING
+		targetTop		: 'Topmost Window (_top)', // MISSING
+		targetSelf		: 'Same Window (_self)', // MISSING
+		targetParent	: 'Parent Window (_parent)', // MISSING
 
 		// Put the voice-only part of the label in the span.
@@ -117,14 +129,9 @@
 		advanced	: '進階',
 		type		: '超連接類型',
+		toUrl		: 'URL', // MISSING
 		toAnchor	: '本頁錨點',
 		toEmail		: '電子郵件',
-		target		: '目標',
-		targetNotSet	: '<尚未設定>',
-		targetFrame	: '<框架>',
-		targetPopup	: '<快顯視窗>',
-		targetNew	: '新視窗 (_blank)',
-		targetTop	: '最上層視窗 (_top)',
-		targetSelf	: '本視窗 (_self)',
-		targetParent	: '父視窗 (_parent)',
+		targetFrame		: '<框架>',
+		targetPopup		: '<快顯視窗>',
 		targetFrameName	: '目標框架名稱',
 		targetPopupName	: '快顯視窗名稱',
@@ -132,5 +139,5 @@
 		popupResizable	: '可縮放',
 		popupStatusBar	: '狀態列',
-		popupLocationBar	: '網址列',
+		popupLocationBar: '網址列',
 		popupToolbar	: '工具列',
 		popupMenuBar	: '選單列',
@@ -144,5 +151,4 @@
 		id				: 'ID',
 		langDir			: '語言方向',
-		langDirNotSet	: '<尚未設定>',
 		langDirLTR		: '由左而右 (LTR)',
 		langDirRTL		: '由右而左 (RTL)',
@@ -204,5 +210,4 @@
 		border		: '邊框',
 		align		: '對齊',
-		alignNotSet	: '<未設定>',
 		alignLeft	: '靠左對齊',
 		alignCenter	: '置中',
@@ -211,4 +216,5 @@
 		widthPx		: '像素',
 		widthPc		: '百分比',
+		widthUnit	: 'width unit', // MISSING
 		height		: '高度',
 		cellSpace	: '間距',
@@ -261,5 +267,5 @@
 			invalidRowSpan	: '儲存格列數必須為整數格式',
 			invalidColSpan	: '儲存格欄數度必須為整數格式',
-			chooseColor : 'Choose' // MISSING
+			chooseColor		: 'Choose' // MISSING
 		},
 
@@ -308,11 +314,5 @@
 		action		: '動作',
 		method		: '方法',
-		encoding	: '表單編碼',
-		target		: '目標',
-		targetNotSet	: '<尚未設定>',
-		targetNew	: '新視窗 (_blank)',
-		targetTop	: '最上層視窗 (_top)',
-		targetSelf	: '本視窗 (_self)',
-		targetParent	: '父視窗 (_parent)'
+		encoding	: '表單編碼'
 	},
 
@@ -372,25 +372,29 @@
 		titleButton	: '影像按鈕屬性',
 		menu		: '影像屬性',
-		infoTab	: '影像資訊',
+		infoTab		: '影像資訊',
 		btnUpload	: '上傳至伺服器',
-		url		: 'URL',
-		upload	: '上傳',
-		alt		: '替代文字',
+		upload		: '上傳',
+		alt			: '替代文字',
 		width		: '寬度',
-		height	: '高度',
+		height		: '高度',
 		lockRatio	: '等比例',
+		unlockRatio	: 'Unlock Ratio', // MISSING
 		resetSize	: '重設為原大小',
-		border	: '邊框',
-		hSpace	: '水平距離',
-		vSpace	: '垂直距離',
+		border		: '邊框',
+		hSpace		: '水平距離',
+		vSpace		: '垂直距離',
 		align		: '對齊',
 		alignLeft	: '靠左對齊',
 		alignRight	: '靠右對齊',
-		preview	: '預覽',
 		alertUrl	: '請輸入影像 URL',
-		linkTab	: '超連結',
+		linkTab		: '超連結',
 		button2Img	: '要把影像按鈕改成影像嗎？',
 		img2Button	: '要把影像改成影像按鈕嗎？',
-		urlMissing : 'Image source URL is missing.' // MISSING
+		urlMissing	: 'Image source URL is missing.', // MISSING
+		validateWidth	: 'Width must be a whole number.', // MISSING
+		validateHeight	: 'Height must be a whole number.', // MISSING
+		validateBorder	: 'Border must be a whole number.', // MISSING
+		validateHSpace	: 'HSpace must be a whole number.', // MISSING
+		validateVSpace	: 'VSpace must be a whole number.' // MISSING
 	},
 
@@ -400,10 +404,10 @@
 		properties		: 'Flash 屬性',
 		propertiesTab	: '屬性',
-		title		: 'Flash 屬性',
-		chkPlay		: '自動播放',
-		chkLoop		: '重複',
-		chkMenu		: '開啟選單',
-		chkFull		: '啟動全螢幕顯示',
- 		scale		: '縮放',
+		title			: 'Flash 屬性',
+		chkPlay			: '自動播放',
+		chkLoop			: '重複',
+		chkMenu			: '開啟選單',
+		chkFull			: '啟動全螢幕顯示',
+ 		scale			: '縮放',
 		scaleAll		: '全部顯示',
 		scaleNoBorder	: '無邊框',
@@ -411,38 +415,38 @@
 		access			: '允許腳本訪問',
 		accessAlways	: '永遠',
-		accessSameDomain	: '相同域名',
-		accessNever	: '永不',
-		align		: '對齊',
-		alignLeft	: '靠左對齊',
-		alignAbsBottom: '絕對下方',
-		alignAbsMiddle: '絕對中間',
+		accessSameDomain: '相同域名',
+		accessNever		: '永不',
+		align			: '對齊',
+		alignLeft		: '靠左對齊',
+		alignAbsBottom	: '絕對下方',
+		alignAbsMiddle	: '絕對中間',
 		alignBaseline	: '基準線',
-		alignBottom	: '靠下對齊',
-		alignMiddle	: '置中對齊',
-		alignRight	: '靠右對齊',
+		alignBottom		: '靠下對齊',
+		alignMiddle		: '置中對齊',
+		alignRight		: '靠右對齊',
 		alignTextTop	: '文字上方',
-		alignTop	: '靠上對齊',
-		quality		: '質素',
-		qualityBest		 : '最好',
-		qualityHigh		 : '高',
-		qualityAutoHigh	 : '高（自動）',
-		qualityMedium	 : '中（自動）',
-		qualityAutoLow	 : '低（自動）',
-		qualityLow		 : '低',
-		windowModeWindow	 : '視窗',
-		windowModeOpaque	 : '不透明',
-		windowModeTransparent	 : '透明',
-		windowMode	: '視窗模式',
-		flashvars	: 'Flash 變數',
-		bgcolor	: '背景顏色',
-		width	: '寬度',
-		height	: '高度',
-		hSpace	: '水平距離',
-		vSpace	: '垂直距離',
-		validateSrc : '請輸入欲連結的 URL',
-		validateWidth : '寬度必須為數字格式',
-		validateHeight : '高度必須為數字格式',
-		validateHSpace : '水平間距必須為數字格式',
-		validateVSpace : '垂直間距必須為數字格式'
+		alignTop		: '靠上對齊',
+		quality			: '質素',
+		qualityBest		: '最好',
+		qualityHigh		: '高',
+		qualityAutoHigh	: '高（自動）',
+		qualityMedium	: '中（自動）',
+		qualityAutoLow	: '低（自動）',
+		qualityLow		: '低',
+		windowModeWindow: '視窗',
+		windowModeOpaque: '不透明',
+		windowModeTransparent : '透明',
+		windowMode		: '視窗模式',
+		flashvars		: 'Flash 變數',
+		bgcolor			: '背景顏色',
+		width			: '寬度',
+		height			: '高度',
+		hSpace			: '水平距離',
+		vSpace			: '垂直距離',
+		validateSrc		: '請輸入欲連結的 URL',
+		validateWidth	: '寬度必須為數字格式',
+		validateHeight	: '高度必須為數字格式',
+		validateHSpace	: '水平間距必須為數字格式',
+		validateVSpace	: '垂直間距必須為數字格式'
 	},
 
@@ -478,18 +482,19 @@
 	elementsPath :
 	{
+		eleLabel : 'Elements path',  // MISSING
 		eleTitle : '%1 元素'
 	},
 
-	numberedlist : '編號清單',
-	bulletedlist : '項目清單',
-	indent : '增加縮排',
-	outdent : '減少縮排',
+	numberedlist	: '編號清單',
+	bulletedlist	: '項目清單',
+	indent			: '增加縮排',
+	outdent			: '減少縮排',
 
 	justify :
 	{
-		left : '靠左對齊',
-		center : '置中',
-		right : '靠右對齊',
-		block : '左右對齊'
+		left	: '靠左對齊',
+		center	: '置中',
+		right	: '靠右對齊',
+		block	: '左右對齊'
 	},
 
@@ -502,28 +507,29 @@
 		copyError	: '瀏覽器的安全性設定不允許編輯器自動執行複製動作。請使用快捷鍵 (Ctrl+C) 複製。',
 		pasteMsg	: '請使用快捷鍵 (<strong>Ctrl+V</strong>) 貼到下方區域中並按下 <strong>確定</strong>',
-		securityMsg	: '因為瀏覽器的安全性設定，本編輯器無法直接存取您的剪貼簿資料，請您自行在本視窗進行貼上動作。'
+		securityMsg	: '因為瀏覽器的安全性設定，本編輯器無法直接存取您的剪貼簿資料，請您自行在本視窗進行貼上動作。',
+		pasteArea	: 'Paste Area' // MISSING
 	},
 
 	pastefromword :
 	{
-		confirmCleanup : '您想貼上的文字似乎是自 Word 複製而來，請問您是否要先清除 Word 的格式後再行貼上？',
-		toolbar : '自 Word 貼上',
-		title : '自 Word 貼上',
-		error : 'It was not possible to clean up the pasted data due to an internal error' // MISSING
+		confirmCleanup	: '您想貼上的文字似乎是自 Word 複製而來，請問您是否要先清除 Word 的格式後再行貼上？',
+		toolbar			: '自 Word 貼上',
+		title			: '自 Word 貼上',
+		error			: 'It was not possible to clean up the pasted data due to an internal error' // MISSING
 	},
 
 	pasteText :
 	{
-		button : '貼為純文字格式',
-		title : '貼為純文字格式'
+		button	: '貼為純文字格式',
+		title	: '貼為純文字格式'
 	},
 
 	templates :
 	{
-		button : '樣版',
-		title : '內容樣版',
-		insertOption: '取代原有內容',
-		selectPromptMsg: '請選擇欲開啟的樣版<br> (原有的內容將會被清除):',
-		emptyListMsg : '(無樣版)'
+		button			: '樣版',
+		title			: '內容樣版',
+		insertOption	: '取代原有內容',
+		selectPromptMsg	: '請選擇欲開啟的樣版<br> (原有的內容將會被清除):',
+		emptyListMsg	: '(無樣版)'
 	},
 
@@ -532,29 +538,26 @@
 	stylesCombo :
 	{
-		label : '樣式',
-		voiceLabel : '樣式',
-		panelVoiceLabel : '選擇樣式',
-		panelTitle1 : '塊級元素樣式',
-		panelTitle2 : '內聯元素樣式',
-		panelTitle3 : '物件元素樣式'
+		label		: '樣式',
+		panelTitle	: 'Formatting Styles', // MISSING
+		panelTitle1	: '塊級元素樣式',
+		panelTitle2	: '內聯元素樣式',
+		panelTitle3	: '物件元素樣式'
 	},
 
 	format :
 	{
-		label : '格式',
-		voiceLabel : '格式',
-		panelTitle : '格式',
-		panelVoiceLabel : '選擇段落格式',
-
-		tag_p : '一般',
-		tag_pre : '已格式化',
-		tag_address : '位址',
-		tag_h1 : '標題 1',
-		tag_h2 : '標題 2',
-		tag_h3 : '標題 3',
-		tag_h4 : '標題 4',
-		tag_h5 : '標題 5',
-		tag_h6 : '標題 6',
-		tag_div : '一般 (DIV)'
+		label		: '格式',
+		panelTitle	: '格式',
+
+		tag_p		: '一般',
+		tag_pre		: '已格式化',
+		tag_address	: '位址',
+		tag_h1		: '標題 1',
+		tag_h2		: '標題 2',
+		tag_h3		: '標題 3',
+		tag_h4		: '標題 4',
+		tag_h5		: '標題 5',
+		tag_h6		: '標題 6',
+		tag_div		: '一般 (DIV)'
 	},
 
@@ -578,24 +581,23 @@
 	font :
 	{
-		label : '字體',
-		voiceLabel : '字體',
-		panelTitle : '字體',
-		panelVoiceLabel : '選擇字體'
+		label		: '字體',
+		voiceLabel	: '字體',
+		panelTitle	: '字體'
 	},
 
 	fontSize :
 	{
-		label : '大小',
-		voiceLabel : '文字大小',
-		panelTitle : '大小',
-		panelVoiceLabel : '選擇文字大小'
+		label		: '大小',
+		voiceLabel	: '文字大小',
+		panelTitle	: '大小'
 	},
 
 	colorButton :
 	{
-		textColorTitle : '文字顏色',
-		bgColorTitle : '背景顏色',
-		auto : '自動',
-		more : '更多顏色…'
+		textColorTitle	: '文字顏色',
+		bgColorTitle	: '背景顏色',
+		panelTitle		: 'Colors', // MISSING
+		auto			: '自動',
+		more			: '更多顏色…'
 	},
 
@@ -646,28 +648,28 @@
 	scayt :
 	{
-		title : '即時拼寫檢查',
-		enable : '啟用即時拼寫檢查',
-		disable : '關閉即時拼寫檢查',
-		about : '關於即時拼寫檢查',
-		toggle : '啟用／關閉即時拼寫檢查',
-		options : '選項',
-		langs : '語言',
-		moreSuggestions : '更多拼寫建議',
-		ignore : '忽略',
-		ignoreAll : '全部忽略',
-		addWord : '添加單詞',
-		emptyDic : '字典名不應為空.',
-		optionsTab : '選項',
-		languagesTab : '語言',
-		dictionariesTab : '字典',
-		aboutTab : '關於'
+		title			: '即時拼寫檢查',
+		enable			: '啟用即時拼寫檢查',
+		disable			: '關閉即時拼寫檢查',
+		about			: '關於即時拼寫檢查',
+		toggle			: '啟用／關閉即時拼寫檢查',
+		options			: '選項',
+		langs			: '語言',
+		moreSuggestions	: '更多拼寫建議',
+		ignore			: '忽略',
+		ignoreAll		: '全部忽略',
+		addWord			: '添加單詞',
+		emptyDic		: '字典名不應為空.',
+		optionsTab		: '選項',
+		languagesTab	: '語言',
+		dictionariesTab	: '字典',
+		aboutTab		: '關於'
 	},
 
 	about :
 	{
-		title : '關於 CKEditor',
-		dlgTitle : '關於 CKEditor',
-		moreInfo : '訪問我們的網站以獲取更多關於協議的信息',
-		copy : 'Copyright &copy; $1. All rights reserved.'
+		title		: '關於 CKEditor',
+		dlgTitle	: '關於 CKEditor',
+		moreInfo	: '訪問我們的網站以獲取更多關於協議的信息',
+		copy		: 'Copyright &copy; $1. All rights reserved.'
 	},
 
@@ -677,8 +679,8 @@
 	fakeobjects :
 	{
-		anchor : '錨點',
-		flash : 'Flash 動畫',
-		div : '分頁',
-		unknown : '不明物件'
+		anchor	: '錨點',
+		flash	: 'Flash 動畫',
+		div		: '分頁',
+		unknown	: '不明物件'
 	},
 
@@ -687,11 +689,11 @@
 	colordialog :
 	{
-		title : 'Select color', // MISSING
-		highlight : 'Highlight', // MISSING
-		selected : 'Selected', // MISSING
-		clear : 'Clear' // MISSING
-	},
-
-	toolbarCollapse : 'Collapse Toolbar', // MISSING
-	toolbarExpand : 'Expand Toolbar' // MISSING
+		title		: 'Select color', // MISSING
+		highlight	: 'Highlight', // MISSING
+		selected	: 'Selected', // MISSING
+		clear		: 'Clear' // MISSING
+	},
+
+	toolbarCollapse	: 'Collapse Toolbar', // MISSING
+	toolbarExpand	: 'Expand Toolbar' // MISSING
 };
Index: CKEditor/trunk/_source/plugins/a11yhelp/dialogs/a11yhelp.js
===================================================================
--- CKEditor/trunk/_source/plugins/a11yhelp/dialogs/a11yhelp.js	(revision 5189)
+++ CKEditor/trunk/_source/plugins/a11yhelp/dialogs/a11yhelp.js	(revision 5189)
@@ -0,0 +1,211 @@
+/*
+Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+*/
+
+CKEDITOR.dialog.add( 'a11yHelp', function( editor )
+{
+	var lang = editor.lang.accessibilityHelp,
+		id = CKEDITOR.tools.getNextNumber();
+
+	// CharCode <-> KeyChar.
+	var keyMap =
+	{
+		8 : "BACKSPACE",
+		9 : "TAB" ,
+		13 : "ENTER" ,
+		16 : "SHIFT" ,
+		17 : "CTRL" ,
+		18 : "ALT" ,
+		19 : "PAUSE" ,
+		20 : "CAPSLOCK" ,
+		27 : "ESCAPE" ,
+		33 : "PAGE UP" ,
+		34 : "PAGE DOWN" ,
+		35 : "END" ,
+		36 : "HOME" ,
+		37 : "LEFT ARROW" ,
+		38 : "UP ARROW" ,
+		39 : "RIGHT ARROW" ,
+		40 : "DOWN ARROW" ,
+		45 : "INSERT" ,
+		46 : "DELETE" ,
+		91 : "LEFT WINDOW KEY" ,
+		92 : "RIGHT WINDOW KEY" ,
+		93 : "SELECT KEY" ,
+		96 : "NUMPAD  0" ,
+		97 : "NUMPAD  1" ,
+		98 : "NUMPAD  2" ,
+		99 : "NUMPAD  3" ,
+		100 : "NUMPAD  4" ,
+		101 : "NUMPAD  5" ,
+		102 : "NUMPAD  6" ,
+		103 : "NUMPAD  7" ,
+		104 : "NUMPAD  8" ,
+		105 : "NUMPAD  9" ,
+		106 : "MULTIPLY" ,
+		107 : "ADD" ,
+		109 : "SUBTRACT" ,
+		110 : "DECIMAL POINT" ,
+		111 : "DIVIDE" ,
+		112 : "F1" ,
+		113 : "F2" ,
+		114 : "F3" ,
+		115 : "F4" ,
+		116 : "F5" ,
+		117 : "F6" ,
+		118 : "F7" ,
+		119 : "F8" ,
+		120 : "F9" ,
+		121 : "F10" ,
+		122 : "F11" ,
+		123 : "F12" ,
+		144 : "NUM LOCK" ,
+		145 : "SCROLL LOCK" ,
+		186 : "SEMI-COLON" ,
+		187 : "EQUAL SIGN" ,
+		188 : "COMMA" ,
+		189 : "DASH" ,
+		190 : "PERIOD" ,
+		191 : "FORWARD SLASH" ,
+		192 : "GRAVE ACCENT" ,
+		219 : "OPEN BRACKET" ,
+		220 : "BACK SLASH" ,
+		221 : "CLOSE BRAKET" ,
+		222 : "SINGLE QUOTE"
+	};
+
+	// Modifier keys override.
+	keyMap[ CKEDITOR.ALT ] = 'ALT';
+	keyMap[ CKEDITOR.SHIFT ] = 'SHIFT';
+	keyMap[ CKEDITOR.CTRL ] = 'CTRL';
+
+	// Sort in desc.
+	var modifiers = [ CKEDITOR.ALT, CKEDITOR.SHIFT, CKEDITOR.CTRL ];
+
+	function representKeyStroke( keystroke )
+	{
+		var quotient,
+				modifier,
+				presentation = [];
+
+		for ( var i = 0; i < modifiers.length; i++ )
+		{
+			modifier = modifiers[ i ];
+			quotient = keystroke / modifiers[ i ];
+			if ( quotient > 1 && quotient <= 2 )
+			{
+				keystroke -= modifier;
+				presentation.push( keyMap[ modifier ] );
+			}
+		}
+
+		presentation.push( keyMap[ keystroke ]
+			|| String.fromCharCode( keystroke ) );
+
+		return presentation.join( '+' );
+	}
+
+	var variablesPattern = /\$\{(.*?)\}/g;
+	function replaceVariables( match, name )
+	{
+		var keystrokes = editor.config.keystrokes,
+				definition,
+				length = keystrokes.length;
+
+		for ( var i = 0; i < length; i++ )
+		{
+			definition = keystrokes[ i ];
+			if ( definition[ 1 ] == name )
+				break;
+		}
+		return representKeyStroke( definition[ 0 ] );
+	}
+
+	// Create the help list directly from lang file entries.
+	function buildHelpContents()
+	{
+		var pageTpl = '<div class="cke_accessibility_legend" role="document" aria-labelledby="cke_' + id + '_arialbl" tabIndex="-1">%1</div>' +
+				'<span id="cke_' + id + '_arialbl" class="cke_voice_label">' + lang.contents + ' </span>',
+			sectionTpl = '<h1>%1</h1><dl>%2</dl>',
+			itemTpl = '<dt>%1</dt><dd>%2</dd>';
+
+		var pageHtml = [],
+			sections = lang.legend,
+			sectionLength = sections.length;
+
+		for ( var i = 0; i < sectionLength; i++ )
+		{
+			var section = sections[ i ],
+				sectionHtml = [],
+				items = section.items,
+				itemsLength = items.length;
+
+			for ( var j = 0; j < itemsLength; j++ )
+			{
+				var item = items[ j ],
+					itemHtml;
+				itemHtml = itemTpl.replace( '%1', item.name ).
+					replace( '%2', item.legend.replace( variablesPattern, replaceVariables ) );
+				sectionHtml.push( itemHtml );
+			}
+
+			pageHtml.push( sectionTpl.replace( '%1', section.name ).replace( '%2', sectionHtml.join( '' ) ) );
+		}
+
+		return pageTpl.replace( '%1', pageHtml.join( '' ) );
+	}
+
+	return {
+		title : lang.title,
+		minWidth : 600,
+		minHeight : 400,
+		contents : [
+			{
+				id : 'info',
+				label : editor.lang.common.generalTab,
+				expand : true,
+				elements :
+				[
+					{
+						type : 'html',
+						id : 'legends',
+						focus : function() {},
+						html : buildHelpContents() +
+							'<style type="text/css">' +
+							'.cke_accessibility_legend' +
+							'{' +
+								'width:600px;' +
+								'height:400px;' +
+								'padding-right:5px;' +
+								'overflow-y:auto;' +
+								'overflow-x:hidden;' +
+							'}' +
+							'.cke_accessibility_legend h1' +
+							'{' +
+								'font-size: 20px;' +
+								'border-bottom: 1px solid #AAA;' +
+								'margin: 5px 0px 15px;' +
+							'}' +
+							'.cke_accessibility_legend dl' +
+							'{' +
+								'margin-left: 5px;' +
+							'}' +
+							'.cke_accessibility_legend dt' +
+							'{' +
+								'font-size: 13px;' +
+								'font-weight: bold;' +
+							'}' +
+							'.cke_accessibility_legend dd' +
+							'{' +
+								'white-space:normal;' +
+								'margin:10px' +
+							'}' +
+						'</style>'
+					}
+				]
+			}
+		],
+		buttons : [ CKEDITOR.dialog.cancelButton ]
+	};
+});
Index: CKEditor/trunk/_source/plugins/a11yhelp/lang/en.js
===================================================================
--- CKEditor/trunk/_source/plugins/a11yhelp/lang/en.js	(revision 5189)
+++ CKEditor/trunk/_source/plugins/a11yhelp/lang/en.js	(revision 5189)
@@ -0,0 +1,108 @@
+/*
+Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+*/
+
+CKEDITOR.plugins.setLang( 'a11yhelp', 'en',
+{
+	accessibilityHelp :
+	{
+		title : 'Accessibility Instructions',
+		contents : 'Help Contents. To close this dialog press ESC.',
+		legend :
+		[
+			{
+				name : 'General',
+				items :
+						[
+							{
+								name : 'Editor Toolbar',
+								legend:
+									'Press ${toolbarFocus} to navigate to the toolbar. ' +
+									'Move to next toolbar button with TAB or RIGHT ARROW. ' +
+									'Move to previous button with SHIFT+TAB or LEFT ARROW. ' +
+									'Press SPACE or ENTER to activate the toolbar button.'
+							},
+
+							{
+								name : 'Editor Dialog',
+								legend :
+									'Inside a dialog, press TAB to navigate to next dialog field, press SHIFT + TAB to move to previous field, press ENTER to submit dialog, press ESC to cancel dialog. ' +
+									'For dialogs that have multiple tab pages, press ALT + F10 to navigate to tab-list. ' +
+									'Then move to next tab with TAB OR RIGTH ARROW. ' +
+									'Move to previous tab with SHIFT + TAB or LEFT ARROW. ' +
+									'Press SPACE or ENTER to select the tab page.'
+							},
+
+							{
+								name : 'Editor Context Menu',
+								legend :
+									'Press ${contextMenu} or APPLICATION KEY to open context-menu. ' +
+									'Then move to next menu option with TAB or DOWN ARROW. ' +
+									'Move to previous option with  SHIFT+TAB or UP ARROW. ' +
+									'Press SPACE or ENTER to select the menu option. ' +
+									'Open sub-menu of current option wtih SPACE or ENTER or RIGHT ARROW. ' +
+									'Go back to parent menu item with ESC or LEFT ARROW. ' +
+									'Close context menu with ESC.'
+							},
+
+							{
+								name : 'Editor List Box',
+								legend :
+									'Inside a list-box, move to next list item with TAB OR DOWN ARROW. ' +
+									'Move to previous list item with SHIFT + TAB or UP ARROW. ' +
+									'Press SPACE or ENTER to select the list option. ' +
+									'Press ESC to close the list-box.'
+							},
+
+							{
+								name : 'Editor Element Path Bar',
+								legend :
+									'Press ${elementsPathFocus} to navigate to the elements path bar. ' +
+									'Move to next element button with TAB or RIGHT ARROW. ' +
+									'Move to previous button with  SHIFT+TAB or LEFT ARROW. ' +
+									'Press SPACE or ENTER to select the element in editor.'
+							}
+						]
+			},
+			{
+				name : 'Commands',
+				items :
+						[
+							{
+								name : ' Undo command',
+								legend : 'Press ${undo}'
+							},
+							{
+								name : ' Redo command',
+								legend : 'Press ${redo}'
+							},
+							{
+								name : ' Bold command',
+								legend : 'Press ${bold}'
+							},
+							{
+								name : ' Italic command',
+								legend : 'Press ${italic}'
+							},
+							{
+								name : ' Underline command',
+								legend : 'Press ${underline}'
+							},
+							{
+								name : ' Link command',
+								legend : 'Press ${link}'
+							},
+							{
+								name : ' Toolbar Collapse command',
+								legend : 'Press ${toolbarCollapse}'
+							},
+							{
+								name : ' Accessibility Help',
+								legend : 'Press ${a11yHelp}'
+							}
+						]
+			}
+		]
+	}
+});
Index: CKEditor/trunk/_source/plugins/a11yhelp/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/a11yhelp/plugin.js	(revision 5189)
+++ CKEditor/trunk/_source/plugins/a11yhelp/plugin.js	(revision 5189)
@@ -0,0 +1,46 @@
+/*
+Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+*/
+
+/**
+ * @fileOverview Plugin definition for the a11yhelp, which provides a dialog
+ * with accessibility related help.
+ */
+
+(function()
+{
+	var pluginName = 'a11yhelp',
+		commandName = 'a11yHelp';
+
+	CKEDITOR.plugins.add( pluginName,
+	{
+		// List of available localizations.
+		availableLangs : { en:1 },
+
+		init : function( editor )
+		{
+			var plugin = this;
+			editor.addCommand( commandName,
+				{
+					exec : function()
+					{
+						var langCode = editor.langCode;
+						langCode = plugin.availableLangs[ langCode ] ? langCode : 'en';
+
+						CKEDITOR.scriptLoader.load(
+								CKEDITOR.getUrl( plugin.path + 'lang/' + langCode + '.js' ),
+								function()
+								{
+									CKEDITOR.tools.extend( editor.lang, plugin.lang[ langCode ] );
+									editor.openDialog( commandName );
+								});
+					},
+					modes : { wysiwyg:1, source:1 },
+					canUndo : false
+				});
+
+			CKEDITOR.dialog.add( commandName, this.path + 'dialogs/a11yhelp.js' );
+		}
+	});
+})();
Index: CKEditor/trunk/_source/plugins/button/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/button/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/button/plugin.js	(revision 5189)
@@ -1,3 +1,3 @@
-﻿/*
+/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -135,8 +135,12 @@
 			'<span class="cke_button">',
 			'<a id="', id, '"' +
-				' class="', classes, '" href="javascript:void(\'', ( this.title || '' ).replace( "'", '' ), '\')"' +
+				' class="', classes, '"',
+				env.gecko && env.version >= 10900 && !env.hc  ? '' : '" href="javascript:void(\''+ ( this.title || '' ).replace( "'"+ '' )+ '\')"',
 				' title="', this.title, '"' +
 				' tabindex="-1"' +
-				' hidefocus="true"' );
+				' hidefocus="true"' +
+			    ' role="button"' +
+				' aria-labelledby="' + id + '_label"' +
+				( this.hasArrow ?  ' aria-haspopup="true"' : '' ) );
 
 		// Some browsers don't cancel key events in the keydown but in the
@@ -171,5 +175,5 @@
 		output.push(
 					'></span>' +
-					'<span class="cke_label">', this.label, '</span>' );
+					'<span id="', id, '_label" class="cke_label">', this.label, '</span>' );
 
 		if ( this.hasArrow )
@@ -192,5 +196,7 @@
 	{
 		if ( this._.state == state )
-			return;
+			return false;
+
+		this._.state = state;
 
 		var element = CKEDITOR.document.getById( this._.id );
@@ -199,16 +205,16 @@
 		{
 			element.setState( state );
-
-			var htmlTitle = this.title,
-				unavailable = this._.editor.lang.common.unavailable,
-				labelElement = element.getChild( 1 );
-
-			if ( state == CKEDITOR.TRISTATE_DISABLED )
-				htmlTitle = unavailable.replace( '%1', this.title );
-
-			labelElement.setHtml( htmlTitle );
-		}
-
-		this._.state = state;
+			state == CKEDITOR.TRISTATE_DISABLED ?
+				element.setAttribute( 'aria-disabled', true ) :
+				element.removeAttribute( 'aria-disabled' );
+
+			state == CKEDITOR.TRISTATE_ON ?
+				element.setAttribute( 'aria-pressed', true ) :
+				element.removeAttribute( 'aria-pressed' );
+
+			return true;
+		}
+		else
+			return false;
 	}
 };
Index: CKEditor/trunk/_source/plugins/clipboard/dialogs/paste.js
===================================================================
--- CKEditor/trunk/_source/plugins/clipboard/dialogs/paste.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/clipboard/dialogs/paste.js	(revision 5189)
@@ -6,42 +6,92 @@
 CKEDITOR.dialog.add( 'paste', function( editor )
 {
+	var lang = editor.lang.clipboard;
 	var isCustomDomain = CKEDITOR.env.isCustomDomain();
 
+	function onPasteFrameLoad( win )
+	{
+		var doc =  new CKEDITOR.dom.document( win.document ),
+			$ = doc.$;
+
+		doc.getById( "cke_actscrpt" ).remove();
+
+		CKEDITOR.env.ie ?
+			$.body.contentEditable = "true" :
+			$.designMode = "on";
+
+		CKEDITOR.env.ie && doc.getWindow().on( 'blur', function()
+		{
+			 $.body.contentEditable = "false";
+		} );
+
+		doc.on( "keydown", function( e )
+		{
+			var domEvent = e.data,
+				key = domEvent.getKeystroke(),
+				processed;
+
+			switch( key )
+			{
+				case 27 :
+					this.hide();
+					processed = 1;
+					break;
+
+				case 9 :
+				case CKEDITOR.SHIFT + 9 :
+					this.changeFocus( true );
+					processed = 1;
+			}
+
+			processed && domEvent.preventDefault();
+		}, this );
+
+		editor.fire( 'ariaWidget', new CKEDITOR.dom.element( win.frameElement ) );
+	}
+
 	return {
-		title : editor.lang.clipboard.title,
+		title : lang.title,
 
 		minWidth : CKEDITOR.env.ie && CKEDITOR.env.quirks ? 370 : 350,
 		minHeight : CKEDITOR.env.quirks ? 250 : 245,
-		htmlToLoad : '<!doctype html><script type="text/javascript">'
-				+ 'window.onload = function()'
-				+ '{'
-					+ 'if ( ' + CKEDITOR.env.ie + ' ) '
-						+ 'document.body.contentEditable = "true";'
-					+ 'else '
-						+ 'document.designMode = "on";'
-					+ 'var iframe = new window.parent.CKEDITOR.dom.element( frameElement );'
-					+ 'var dialog = iframe.getCustomData( "dialog" );'
-		      + ''
-					+ 'iframe.getFrameDocument().on( "keydown", function( e )\
-						{\
-							if ( e.data.getKeystroke() == 27 )\
-								dialog.hide();\
-						});'
-				+ '};'
-				+ '</script><style>body { margin: 3px; height: 95%; } </style><body></body>',
-
 		onShow : function()
 		{
-			if ( CKEDITOR.env.ie )
-				this.getParentEditor().document.getBody().$.contentEditable = 'false';
-
 			// FIREFOX BUG: Force the browser to render the dialog to make the to-be-
 			// inserted iframe editable. (#3366)
 			this.parts.dialog.$.offsetHeight;
 
-			var container = this.getContentElement( 'general', 'editing_area' ).getElement(),
-				iframe = CKEDITOR.dom.element.createFromHtml( '<iframe src="javascript:void(0)" frameborder="0" allowtransparency="1"></iframe>' );
+			var htmlToLoad = '<!doctype html><html><head><style>body { margin: 3px; height: 95%; } </style></head><body>' +
+							 '<script id="cke_actscrpt" type="text/javascript">' +
+							 'window.parent.CKEDITOR.tools.callFunction( ' + CKEDITOR.tools.addFunction( onPasteFrameLoad, this ) + ', this );' +
+							 '</script></body></html>';
 
-			var lang = this.getParentEditor().lang;
+			var iframe = CKEDITOR.dom.element.createFromHtml(
+						'<iframe' +
+						' frameborder="0" ' +
+						' allowTransparency="true"' +
+						// Support for custom document.domain in IE.
+						( isCustomDomain ?
+							' src="javascript:void((function(){' +
+								'document.open();' +
+								'document.domain=\'' + document.domain + '\';' +
+								'document.close();' +
+							'})())"' : '' ) +
+						' role="region"' +
+						' aria-label="' + lang.pasteArea + '"' +
+						' aria-describedby="' + this.getContentElement( 'general', 'pasteMsg' ).domId + '"' +
+						' aria-multiple="true"' +
+						'></iframe>' );
+
+			iframe.on( 'load', function( e )
+			{
+				e.removeListener();
+				var doc = iframe.getFrameDocument().$;
+				// Custom domain handling is needed after each document.open().
+				doc.open();
+				if ( isCustomDomain )
+					doc.domain = document.domain;
+				doc.write( htmlToLoad );
+				doc.close();
+			}, this );
 
 			iframe.setStyles(
@@ -54,46 +104,16 @@
 			iframe.setCustomData( 'dialog', this );
 
-			var accTitle = lang.editorTitle.replace( '%1', lang.clipboard.title );
+			var field = this.getContentElement( 'general', 'editing_area' ),
+				container = field.getElement();
+			container.setHtml( '' );
+			container.append( iframe );
 
+			field.getInputElement = function(){ return iframe; };
+
+			// Force container to scale in IE.
 			if ( CKEDITOR.env.ie )
-				container.setHtml( '<legend style="position:absolute;top:-1000000px;left:-1000000px;">'
-						+ CKEDITOR.tools.htmlEncode( accTitle )
-						+ '</legend>' );
-			else
 			{
-				container.setHtml( '' );
-				container.setAttributes(
-					{
-						role : 'region',
-						title : accTitle
-					} );
-				iframe.setAttributes(
-					{
-						role : 'region',
-						title : ' '
-					} );
-			}
-			container.append( iframe );
-			if ( CKEDITOR.env.ie )
+				container.setStyle( 'display', 'block' );
 				container.setStyle( 'height', ( iframe.$.offsetHeight + 2 ) + 'px' );
-
-			if ( isCustomDomain )
-			{
-				CKEDITOR._cke_htmlToLoad = this.definition.htmlToLoad;
-				iframe.setAttribute( 'src',
-					'javascript:void( (function(){' +
-						   'document.open();' +
-						   'document.domain="' + document.domain + '";' +
-						   'document.write( window.parent.CKEDITOR._cke_htmlToLoad );' +
-						   'delete window.parent.CKEDITOR._cke_htmlToLoad;' +
-						   'document.close();' +
-					'})() )' );
-			}
-			else
-			{
-				var doc = iframe.$.contentWindow.document;
-				doc.open();
-				doc.write( this.definition.htmlToLoad );
-				doc.close();
 			}
 		},
@@ -132,10 +152,10 @@
 						type : 'html',
 						id : 'securityMsg',
-						html : '<div style="white-space:normal;width:340px;">' + editor.lang.clipboard.securityMsg + '</div>'
+						html : '<div style="white-space:normal;width:340px;">' + lang.securityMsg + '</div>'
 					},
 					{
 						type : 'html',
 						id : 'pasteMsg',
-						html : '<div style="white-space:normal;width:340px;">'+editor.lang.clipboard.pasteMsg +'</div>'
+						html : '<div style="white-space:normal;width:340px;">'+lang.pasteMsg +'</div>'
 					},
 					{
@@ -143,12 +163,9 @@
 						id : 'editing_area',
 						style : 'width: 100%; height: 100%;',
-						html : '<fieldset></fieldset>',
+						html : '',
 						focus : function()
 						{
-							var div = this.getElement();
-							var iframe = div.getElementsByTag( 'iframe' );
-							if ( iframe.count() < 1 )
-								return;
-							iframe = iframe.getItem( 0 );
+							var win = this.getInputElement().$.contentWindow,
+								 body = win && win.document.body;
 
 							// #3291 : JAWS needs the 500ms delay to detect that the editor iframe
@@ -157,5 +174,7 @@
 							setTimeout( function()
 							{
-								iframe.$.contentWindow.focus();
+								// Reactivate design mode for IE to make the cursor blinking.
+								CKEDITOR.env.ie && body && ( body.contentEditable = "true" );
+								win.focus();
 							}, 500 );
 						}
